<?php
/*
Plugin Name: Finanz-Nachrichten
Plugin URI: http://www.arbeitsgemeinschaft-finanzen.de/plugins.php
Description: Flexibles, anpassbares Widget, das interessante und informative Nachrichten aus dem Finanzsektor bereitstellt. Powered by <a href="http://www.arbeitsgemeinschaft-finanzen.de/">http://www.arbeitsgemeinschaft-finanzen.de/</a>
Version: 1.0
Author: Thomas Nissen
Author URI: http://www.arbeitsgemeinschaft-finanzen.de/
License: GPL3
*/

function finanznews()
{
  $options = get_option("widget_finanznews");
  if (!is_array($options)){
    $options = array(
      'title' => 'Finanz-Nachrichten',
      'news' => '5',
      'chars' => '30',
      'backlink' => 'nein'
    );
  }
  
  	$timestamp = time();
	$timestamp_finanznews = get_option('timestamp_finanznews', 0);	
	$zeitunterschied =  $timestamp - $timestamp_finanznews;
	
	//1 Woche: 604800
	if ($zeitunterschied >= 604800) {
		$blog_url = urlencode(get_bloginfo('url'));
		$url = "http://www.arbeitsgemeinschaft-finanzen.de/tagesgeldzinsen/wplog.php?url=". $blog_url;
		curl_callhome($url);		
		update_option('timestamp_finanznews', $timestamp);		
	}

  // RSS Objekt erzeugen 
  $rss = simplexml_load_file( 
  'http://www.arbeitsgemeinschaft-finanzen.de/feed.xml'); 
  ?>

<ul>
  <?php 
  // maximale Anzahl an News, wobei 0 (Null) alle anzeigt
  $max_news = $options['news'];
  // maximale Lnge, auf die ein Titel, falls notwendig, gekrzt wird
  $max_length = $options['chars'];
  
  // RSS Elemente durchlaufen 
  $cnt = 0;
  foreach($rss->channel->item as $i) { 
    if($max_news > 0 AND $cnt >= $max_news){
        break;
    }
    ?>
  <li>
    <?php
    // Titel in Zwischenvariable speichern
    $title = $i->title;
    // Lnge des Titels ermitteln
    $length = strlen($title);
    // wenn der Titel lnger als die vorher definierte Maximallnge ist,
    // wird er gekrzt und mit "..." bereichert, sonst wird er normal ausgegeben
    if($length > $max_length){
      $title = substr($title, 0, $max_length)."...";
    }
    ?>
    <a href="<?=$i->link?>" target="_blank">
    <?=$title?>
    </a> </li>
  <?php 
    $cnt++;
  } 
  ?>
  <?php if ( $options['backlink'] == "ja" ) {?><li><a href="http://www.arbeitsgemeinschaft-finanzen.de/" title="Arbeitsgemeinschaft Finanzen" target="_blank">Arbeitsgemeinschaft Finanzen</a></li><?php } ?>
</ul>
<?php  
}

function widget_finanznews($args)
{
  extract($args);
  
  $options = get_option("widget_finanznews");
  if (!is_array($options)){
    $options = array(
      'title' => 'Finanz-Nachrichten',
      'news' => '5',
      'chars' => '30',
      'backlink' => 'nein'
    );
  }
  
  echo $before_widget;
  echo $before_title;
  echo $options['title'];
  echo $after_title;
  finanznews();
  echo $after_widget;
}

function finanznews_control()
{
  $options = get_option("widget_finanznews");
  if (!is_array($options)){
    $options = array(
      'title' => 'Finanz-Nachrichten',
      'news' => '5',
      'chars' => '30',
      'backlink' => 'nein'
    );
  }
  
  if($_POST['finanznews-Submit'])
  {
    $options['title'] = htmlspecialchars($_POST['finanznews-WidgetTitle']);
    $options['news'] = htmlspecialchars($_POST['finanznews-NewsCount']);
    $options['chars'] = htmlspecialchars($_POST['finanznews-CharCount']);
    $options['backlink'] = htmlspecialchars($_POST['finanznews-Backlink']);
    update_option("widget_finanznews", $options);
  }
?>
<p>
  <label for="finanznews-WidgetTitle">Widget Titel: </label>
  <input type="text" id="finanznews-WidgetTitle" name="finanznews-WidgetTitle" value="<?php echo $options['title'];?>" />
  <br />
  <br />
  <label for="finanznews-NewsCount">Max. Anzahl Nachrichten: </label>
  <input type="text" id="finanznews-NewsCount" name="finanznews-NewsCount" value="<?php echo $options['news'];?>" />
  <br />
  <br />
  <label for="finanznews-CharCount">Max. Anzahl Zeichen: </label>
  <input type="text" id="finanznews-CharCount" name="finanznews-CharCount" value="<?php echo $options['chars'];?>" />
  <br />
  <br />
  <label for="finanznews-Backlink">Backlink anzeigen: </label>
  <select name="finanznews-Backlink"  id="finanznews-Backlink" >
    <option value="nein"<?php if ( $options['backlink'] != "ja" ) {?> selected="selected"<?php } ?>>nein</option>
    <option value="ja"<?php if ( $options['backlink'] == "ja" ) {?> selected="selected"<?php } ?>>ja</option>
  </select>
  <br />
  <br />
  <input type="hidden" id="finanznews-Submit"  name="finanznews-Submit" value="1" />
</p>
<?php
}

function finanznews_init()
{
  register_sidebar_widget(__('Finanz-Nachrichten'), 'widget_finanznews');    
  register_widget_control('Finanz-Nachrichten', 'finanznews_control', 300, 200);
  $timestamp = time();
  add_option('timestamp_finanznews', $timestamp);
}
add_action("plugins_loaded", "finanznews_init");

function curl_callhome($Url){
    if (function_exists('curl_init')){
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $Url);
    curl_setopt($ch, CURLOPT_REFERER, "http://www.example.org/yay.htm");
    curl_setopt($ch, CURLOPT_USERAGENT, "MozillaXYZ/1.0");
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    $output = curl_exec($ch);
    curl_close($ch);
	} 
}
?>
